module(..., package.seeall)

local socket = require("socket")
local http = require("socket.http")
local url = require("socket.url")

--local json = require("json")

--local json = require("os")
--local lQuery = require "../lQuery"
--local log = print
--require "lua_mii_rep"
--local lumiiRep = "lua_mii_rep"
--local lQuery = require "lQuery"


local parse_xml = require "Endpoint.xml_parser"


--funkcija, lai saliktu visus mainigos Url
local function encode_query(query_table)
  local s = ""
  for k, v in pairs(query_table) do
    s = s .. "&" .. url.escape(k) .. "=" .. url.escape(v)
  end
  return string.sub(s, 2)     -- remove first `&'
end

--endpointa adreses un mainigo saliksana kopeja urli
local function build_sparql_query_url(host, query_table)
  local query = url.build({
              --scheme = "http",
              --host = host,
              path = "",
              query = encode_query(query_table)})
	
	local url = host .. query
	return url
end

local function encode_query(query_table)
  local s = ""
  for k, v in pairs(query_table) do
    s = s .. "&" .. url.escape(k) .. "=" .. url.escape(v)
  end
  return string.sub(s, 2)     -- remove first `&'
end

function delete_query()

	lQuery("Query#Query"):each(
		function(obj)
			obj:delete()
		end)

	lQuery("Query#Row"):each(
		function(obj)
			obj:delete()
		end)

	lQuery("Query#Cell"):each(
		function(obj)
			obj:delete()
		end)

	lQuery("Query#Col"):each(
		function(obj)
			obj:delete()
		end)
end

--funkcija, kas sanem endpointu, vaicajumu un rezultatu saglaba modeli
function execute_query(sparql_endpoint, sparql_query)
	--izveidojam uri, ko nostt
	query_url = build_sparql_query_url(sparql_endpoint,
    { query = sparql_query,
      --format = "application/vnd.ms-excel"
	  --format = "application/xml"
	  --format = "application/json"
	  --format = "application/sparql-results+xml",
	  --format = "application/sparql-results+json"
	  --format = "xml"
	  Accept = "application/sparql-results+xml"

    })
	print(query_url)
	local queryfile = io.open("spyEndpointQueries.txt", "w")
	queryfile:write(sparql_query)
	queryfile:write("\n")
	queryfile:write(query_url)
	queryfile:write("\n")
	queryfile:write("\n")
	queryfile:close()
	--saemam rezulttu
	--local headers = ""
	query_result, headers = http.request(query_url)
	--print (http.request(query_url))

	local vaicajums = lQuery.create("Query#Query",
		{URL = query_url,
		query = sparql_query}
		)
	--print(query_result)

	--prbaudm vai atgrieztais rezultts ir bijis ar HTTP statusu 200, jo citos gados ir kaut kdas problmas
	print (headers)
	if not headers or headers ~= 200 then
		local status = ''
			if (headers) then
				status = tostring(headers)
			end
			if query_result then
				local errString = 'Error in HTTP response: ' .. tostring(query_result)
				print (errString)
			elseif (headers) then
				print (status)
				errString = status
			else
				errString = "Error! No additional information available"
			end
			vaicajums:attr({error = errString})
			--LrDialogs.message(errString)
		return false
	end

	--print ("Query result: " .. query_result)
	result_table = parse_xml.collect(query_result)
--[[
	for i,v in ipairs(result_table)
	do
		print(result_table[i])
	end
]]

	--nemam otro, jo pirmais norada xml versiju
	--ja kada xml nav defineta xml versija, tad nem uzreiz pirmo
	local seq = 1
	if # result_table > 1 then
		seq = 2
	end
	x1 = result_table[seq]

	--nemam pirmo dalu, jo taja ir vaicajuma galva, kur ir ierakstiti mainigie
	x2 = x1[1]

	variables = {}
	for i,v in ipairs(x2)
	do
		--izveidojam modeli mainigo kolonas
		lQuery.create("Query#Col",
		{name = v.xarg.name}
		):link("query", vaicajums)
		table.insert(variables, v.xarg.name)
	end


--ja gribam izdrukat visus atlasitos mainigos
--[[	for i,v in ipairs(variables)
	do
		print(v)
	end
]]
	results = {}
	for i,v in ipairs(x1[2])
	do
		a = {}
		row = lQuery.create("Query#Row"):link("query", vaicajums)
		for i1,v1 in ipairs(v)
		do
			y = v1.xarg.name
			z = v1[1][1]
			t = v1[1].label
			cell = lQuery.create("Query#Cell", {
				name = y,
				value = z,
				type = t
			}):link("row", row)

		--	 cell:log("name")
		--	 row:log()
		--	 cell:find("/row"):log()
		--	 row:find("/cell"):log()

			vaicajums:find("/col[name = '" .. y .. "']"):link("cell", cell)
			--vaic:link("cell", cell)
			tt = y .. "_type"
			a[y] = z;
			a[tt] = t;
			--table.insert(a, y, z)
			--table.insert(a, tt, t)
		end
		table.insert(results, a)
	end

	--[[
	print(results[200].name);
	print(results[200].name_type);

	for i,v in ipairs(results)
	do
		for i1,v1 in ipairs(variables)
		do
			--print(v[v1])
		end
	end
	]]

	--print(query_url)

	--local result_json_string = http.request(query_url)

	--print(result_json_string)
	--os.execute("pause")
	return true
end


--funkcija, kas izdzees visas vaicajuma instances

--print(dumptable(result_json_string))
--local json_as_lua_table = json.decode(result_json_string)

--print(dumptable(json_as_lua_table))

--for i, v in ipairs(json_as_lua_table.results.bindings) do
--  print(v.classuri.type, v.classuri.value)
--end
--local sparql_test_query = [[
--PREFIX xsd: <http://www.w3.org/2001/XMLSchema#> select  distinct ?name ?homepage ?title  where {?t0 <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://xmlns.com/foaf/0.1/Person>. ?t1 <http://swrc.ontoware.org/ontology#author> ?t0. ?t1 <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://data.semanticweb.org/ns/swc/ontology#Paper>. OPTIONAL {?t0 <http://xmlns.com/foaf/0.1/name> ?name.  } OPTIONAL {?t0 <http://xmlns.com/foaf/0.1/homepage> ?homepage.  } OPTIONAL {?t1 <http://purl.org/dc/elements/1.1/title> ?title.  } }
--]]
--select count(*) where {?a ?b ?c}
--select ?c where {?a a ?c}
--select  distinct ?d ?b where {?a ?b ?c. ?a a ?d. FILTER isLiteral(?c)}

--local query_url = build_sparql_query_url("85.254.199.47:8899",
--    "/sparql",
--    { query = sparql_test_query,
--      format = "application/vnd.ms-excel"
--    })
