module(..., package.seeall)

utilities = require("utilities")
dialog = require("dialog_utilities")
d = require("dialog")
onto = require("get_onto")
spy = require("Endpoint.Spy_Endpoint")
recalc = require("Association_recalc")

local report = require("reporter.report")
local namedGraphName = ""

--form parameters
formID = "LoadOntology"
formCaption = "Load Ontology"

--checks if this is first open and shows form to load ontology
function open()
	report.event("ViziQuer_ProjectOpen")
	--initialize parameters
	--initParam()
	--check if this is first open (as create project)
--	if utilities.get_tags(lQuery("Project"), "IsFirst"):is_empty() then
		if lQuery("Onto#Element"):is_empty() then
			print ("open!!!")
			form()
			createPrefixes()
		end
		--print("form")
--		endpointForm()
		--set that project info is set
--		utilities.add_tag(lQuery("Project"), "IsFirst", "true", true)
--	end
end

function openReloade()
	report.event("ViziQuer_ProjectOpen")
    form()
	createPrefixes()
end

function createPrefixes()
	-- lQuery("Onto#Prefix"):delete()
	lQuery("Onto#OntologyPrefix"):delete()
	-- createKnownPrefixes()
	local prefixTable = {}
	lQuery("Onto#Element"):each(function(element)
		if prefixTable[element:attr("namespace")]==nil then prefixTable[element:attr("namespace")]=1
		else prefixTable[element:attr("namespace")] = prefixTable[element:attr("namespace")] + 1 end
	end)
	local moreOftenUsedPrefix = ""
	local counter = 0
	--find most often uset prafix
	for key, value in pairs(prefixTable) do
		if value > counter and key~="" then
			moreOftenUsedPrefix = key
			counter = value
		end
	end
	--write prefixes to Onto#Prefix
	for key, value in pairs(prefixTable) do
		if key == moreOftenUsedPrefix then
			lQuery.create("Onto#OntologyPrefix", {fullForm=key, shortForm=":"})
		elseif key~="" then
			if lQuery("Onto#Prefix[fullForm='" .. key .. "']"):is_not_empty() then
				lQuery.create("Onto#OntologyPrefix", {fullForm=key, shortForm=lQuery("Onto#Prefix[fullForm='" .. key .. "']"):attr("shortForm")})
			else
				lQuery.create("Onto#OntologyPrefix", {fullForm=key, shortForm="??"})
			end
		end
	end
end

function createKnownPrefixes()
lQuery.create("Onto#KnownPrefix", {fullForm="http://xmlns.com/foaf/0.1/", shortForm="foaf:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2002/07/owl#", shortForm="owl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/1999/02/22-rdf-syntax-ns#", shortForm="rdf:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2000/01/rdf-schema#", shortForm="rdfs:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://dbpedia.org/property/", shortForm="dbp:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2004/02/skos/core#", shortForm="skos:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2001/XMLSchema#", shortForm="xsd:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2003/01/geo/wgs84_pos#", shortForm="geo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://rdfs.org/sioc/ns#", shortForm="sioc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.wiwiss.fu-berlin.de/suhl/bizer/D2RQ/0.1#", shortForm="d2rq:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/rss/1.0/", shortForm="rss:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://this.invalid/test2#", shortForm="test2:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://swrc.ontoware.org/ontology#", shortForm="swrc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://dbpedia.org/resource/", shortForm="dbpedia:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/rss/1.0/modules/content/", shortForm="content:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanticdesktop.org/ontologies/2007/01/19/nie#", shortForm="nie:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2006/gen/ont#", shortForm="gen:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://dbpedia.org/ontology/", shortForm="dbo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/1999/xhtml/vocab#", shortForm="xhtml:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://dbpedia.org/property/", shortForm="dbpprop:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/dc/terms/", shortForm="dcterms:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.ontotext.com/trree/owlim#", shortForm="owlim:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologies.ezweb.morfeo-project.org/reco/ns#", shortForm="reco:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/swan/1.2/discourse-elements/", shortForm="swande:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/similarity/", shortForm="musim:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2002/xforms/", shortForm="xf:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.oclc.org/NET/sism/0.1/", shortForm="sism:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2002/12/cal/ical#", shortForm="ical:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.aktors.org/ontology/portal#", shortForm="akt:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/ns/earl#", shortForm="earl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/ns/sparql-service-description#", shortForm="sd:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.geonames.org/ontology#", shortForm="geonames:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologi.es/days#", shortForm="days:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/microformat/hmedia/", shortForm="media:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2005/xpath-functions#", shortForm="fn:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://creativecommons.org/ns#", shortForm="cc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/dc/dcmitype/", shortForm="dcmit:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://test2.example.com/", shortForm="test:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.kanzaki.com/ns/music#", shortForm="mu:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://jena.hpl.hp.com/ARQ/function#", shortForm="afn:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://sw.deri.org/2005/08/conf/cfp.owl#", shortForm="cfp:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/cld/terms/", shortForm="cld:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/net/schemas/space/", shortForm="space:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www4.wiwiss.fu-berlin.de/factbook/ns#", shortForm="factbook:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.ordnancesurvey.co.uk/ontology/AdministrativeGeography/v2.0/AdministrativeGeography.rdf#", shortForm="osag:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2002/12/cal/ical#", shortForm="cal:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/net/ns/wordmap#", shortForm="wordmap:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://dig.csail.mit.edu/TAMI/2007/amord/air#", shortForm="air:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.openarchives.org/ore/terms/", shortForm="ore:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/swan/1.2/discourse-relationships/", shortForm="swandr:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/dc/elements/1.1/", shortForm="dcelements:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/daia/", shortForm="daia:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/vann/", shortForm="vann:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/ns/org#", shortForm="org:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/po/", shortForm="po:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://langegger.at/xlwrap/vocab#", shortForm="xl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologi.es/giving#", shortForm="giving:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://jena.hpl.hp.com/2008/tdb#", shortForm="tdb:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://example.org/", shortForm="ex:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2004/03/trix/rdfg-1/", shortForm="rdfg:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2000/10/swap/math#", shortForm="math:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.rdfabout.com/rdf/schema/politico/", shortForm="politico:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://rdfs.org/ns/void#", shortForm="void:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://foaf.qdos.com/lastfm/schema/", shortForm="qdoslf:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/biol/botany#", shortForm="botany:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://umbel.org/umbel#", shortForm="umbel:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2000/10/swap/log#", shortForm="log:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/stuff/rev#", shortForm="rev:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://vocab.deri.ie/am#", shortForm="am:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/changeset/schema#", shortForm="cs:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://rdfs.org/sioc/types#", shortForm="sioct:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://data.semanticweb.org/ns/swc/ontology#", shortForm="swc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologies.smile.deri.ie/2009/02/27/memo#", shortForm="memo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanlink.net/2001/00/semanlink-schema#", shortForm="sl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/05/powder#", shortForm="powder:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://tipsy.googlecode.com/svn/trunk/vocab/pmt#", shortForm="pmt:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/bibo/", shortForm="bibo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.oclc.org/NET/nknouf/ns/bibtex#", shortForm="bibtex:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://bio2rdf.org/", shortForm="bio2rdf:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontomedia/core/expression#", shortForm="ome:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://usefulinc.com/ns/doap#", shortForm="doap:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://vocab.org/waiver/terms/", shortForm="wv:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanticdesktop.org/ontologies/2007/08/15/nrl#", shortForm="nrl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2006/vcard/ns#", shortForm="vcard:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.openrdf.org/config/repository/sail#", shortForm="sr:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.holygoat.co.uk/owl/redwood/0.1/tags/", shortForm="tag:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://xmlns.com/wot/0.1/", shortForm="wot:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://wiss-ki.eu/", shortForm="wisski:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://rdf.freebase.com/ns/", shortForm="fb:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2000/10/swap/pim/contact#", shortForm="con:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/goodrelations/v1#", shortForm="gr:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.cogsci.princeton.edu/~wn/schema/", shortForm="wnschema:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2001/XMLSchema#", shortForm="xs:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://web-semantics.org/ns/opensocial#", shortForm="osoc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/relationship/", shortForm="rel:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/af/", shortForm="af:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/swan/1.2/citations/", shortForm="swanci:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://schemas.talis.com/2005/address/schema#", shortForm="ad:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/stuff/project/", shortForm="prj:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/media/video#", shortForm="video:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/c4dm/event.owl#", shortForm="event:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/swan/1.2/qualifiers/", shortForm="swanq:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://conserv.deri.ie/ontology#", shortForm="conserv:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/uwa/context/hardware.owl#", shortForm="hard:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://kwijibo.talis.com/", shortForm="kwijibo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/net/biblio#", shortForm="biblio:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://schemas.microsoft.com/imm/", shortForm="imm:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://schemas.talis.com/2005/dir/schema#", shortForm="dir:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ramonantonio.net/doac/0.1/#", shortForm="doac:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontomedia/core/space#", shortForm="spc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/dc/dcmitype/", shortForm="dcmitype:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://okkam.org/terms#", shortForm="ok:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/uwa/context/location.owl#", shortForm="loc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://umbel.org/umbel/ne/", shortForm="ne:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2008/content#", shortForm="cnt:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/swan/1.2/qualifiers/", shortForm="swanqs:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2000/10/swap/os#", shortForm="os:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/net/rdf-money/", shortForm="money:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://xmlns.com/wordnet/1.6/", shortForm="wn:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://telegraphis.net/ontology/measurement/code#", shortForm="code:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologi.es/status#", shortForm="status:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2003/11/swrl#", shortForm="swrl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://buzzword.org.uk/rdf/h5#", shortForm="h5:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#", shortForm="ncal:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/swan/1.2/agents/", shortForm="swanag:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/myspace#", shortForm="myspo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://madskills.com/public/xml/rss/module/trackback/", shortForm="trackback:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/uwa/context/deliverycontext.owl#", shortForm="dcn:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#", shortForm="nfo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2003/06/sw-vocab-status/ns#", shortForm="vs:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2000/10/swap/pim/doc#", shortForm="doc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://umbel.org/umbel/ac/", shortForm="ac:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/dc/dcmitype/", shortForm="dctype:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://vocab.sindice.com/xfn#", shortForm="xfn:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.ontologydesignpatterns.org/cp/owl/informationrealization.owl#", shortForm="ir:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanticdesktop.org/ontologies/2008/05/20/tmo#", shortForm="tmo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontomedia/ext/common/being#", shortForm="omb:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanticdesktop.org/ontologies/2007/08/15/nao#", shortForm="nao:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://data.nasa.gov/qudt/owl/unit#", shortForm="unit:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/book/vocab#", shortForm="book:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://umbel.org/umbel/sc/", shortForm="sc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/scovo#", shortForm="scovo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.rdfabout.com/rdf/schema/usbill/", shortForm="bill:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/frbr/core#", shortForm="frbr:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.ontologydesignpatterns.org/cp/owl/timeinterval.owl#", shortForm="ti:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/mo/mit#", shortForm="mit:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://d2rq.org/terms/jdbc/", shortForm="jdbc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://sindice.com/hlisting/0.1/", shortForm="hlisting:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2003/11/swrlb#", shortForm="swrlb:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2004/09/fresnel#", shortForm="fresnel:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ibis#", shortForm="ibis:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.ontologydesignpatterns.org/cp/owl/situation.owl#", shortForm="sit:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ltsc.ieee.org/rdf/lomv1p0/lom#", shortForm="lom:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2000/10/swap/crypto#", shortForm="crypto:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2000/10/swap/list#", shortForm="list:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.aktors.org/ontology/support#", shortForm="akts:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/1999/xhtml/vocab#", shortForm="xhv:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.rkbexplorer.com/ontologies/coref#", shortForm="coref:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://schemas.talis.com/2005/library/schema#", shortForm="lib:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://commontag.org/ns#", shortForm="ctag:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2000/10/swap/string#", shortForm="string:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontomedia/ext/common/bestiary#", shortForm="omc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://vocab.deri.ie/c4n#", shortForm="c4n:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2003/01/geo/wgs84_pos#", shortForm="wgs84:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/mo/", shortForm="mo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.ontologydesignpatterns.org/cp/owl/informationobjectsandrepresentationlanguages.owl#", shortForm="irrl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/aiiso/schema#", shortForm="aiiso:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2003/12/exif/ns#", shortForm="exif:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/myspace#", shortForm="myspace:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://courseware.rkbexplorer.com/ontologies/courseware#", shortForm="courseware:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/chord/", shortForm="chord:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ns.poundhill.com/phss/1.0/", shortForm="phss:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://linkedgeodata.org/vocabulary#", shortForm="lgd:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.rdfabout.com/rdf/schema/usfec/", shortForm="fec:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/commerce#", shortForm="commerce:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/dc/dcam/", shortForm="dcam:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.rdfabout.com/rdf/schema/usgovt/", shortForm="usgov:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://dbpedia.org/resource/", shortForm="dbr:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2009/pointers#", shortForm="ptr:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ltsc.ieee.org/rdf/lomv1p0/vocabulary#", shortForm="lomvoc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2002/xforms/", shortForm="xforms:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/05/powder-s#", shortForm="wdrs:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://dbpedia.org/ontology/", shortForm="dbpediaowl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.ontologydesignpatterns.org/cp/owl/componency.owl#", shortForm="cmp:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.openrdf.org/config/sail#", shortForm="sail:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontomedia/ext/common/trait#", shortForm="omt:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.openrdf.org/rdf/2009/metadata#", shortForm="meta:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.metadata.net/harmony/ABCSchemaV5Commented.rdf#", shortForm="abc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2006/timezone#", shortForm="tzont:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.openrdf.org/config/repository#", shortForm="rep:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/ns/auth/acl#", shortForm="acl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanticdesktop.org/ontologies/2007/11/01/pimo#", shortForm="pimo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.dotnetrdf.org/leviathan#", shortForm="lfn:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/uwa/context/web.owl#", shortForm="web:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/05/powder#", shortForm="wdr:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://data.ordnancesurvey.co.uk/id/", shortForm="osgb:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2006/link#", shortForm="link:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologi.es/profiling#", shortForm="profiling:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://annotation.semanticweb.org/2004/iswc#", shortForm="iswc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www4.wiwiss.fu-berlin.de/dailymed/resource/dailymed/", shortForm="dailymed:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://resex.rkbexplorer.com/ontologies/resex#", shortForm="resex:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://rdf.ecs.soton.ac.uk/ontology/ecs#", shortForm="ecs:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/c4dm/timeline.owl#", shortForm="tl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologi.es/lang/core#", shortForm="lang:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://buzzword.org.uk/rdf/atomix#", shortForm="atomix:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/lifecycle/schema#", shortForm="lifecycle:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://buzzword.org.uk/rdf/xhtml-elements#", shortForm="xhe:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/1999/xhtml/vocab/", shortForm="xhtmlvocab:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/decimalised#", shortForm="ddc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.affymetrix.com/community/publications/affymetrix/tmsplice#", shortForm="affy:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.openrdf.org/config/sail/custom#", shortForm="custom:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/biol/zoology#", shortForm="zoology:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.daml.org/2001/10/html/airport-ont#", shortForm="airport:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/similarity/", shortForm="sim:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://schemas.talis.com/2005/user/schema#", shortForm="user:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/swan/1.2/swan-commons/", shortForm="swanco:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://open.vocab.org/terms/", shortForm="ov:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.ontologydesignpatterns.org/cpont/ire.owl#", shortForm="ire:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2006/time#", shortForm="time:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2000/10/swap/pim/contact#", shortForm="contact:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/riro/sdl#", shortForm="sdl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://topbraid.org/sparqlmotionfunctions#", shortForm="smf:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/swan/1.2/pav/", shortForm="swanpav:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/last-fm/", shortForm="lastfm:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2004/03/trix/swp-2/", shortForm="swp:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.lingvoj.org/ontology#", shortForm="lingvoj:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://spinrdf.org/spin#", shortForm="spin:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/resourcelist/schema#", shortForm="resource:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.junkwork.net/xml/DocumentList#", shortForm="doclist:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/uwa/context/java.owl#", shortForm="java:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/ns/auth/rsa#", shortForm="rsa:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/bio/0.1/", shortForm="bio:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologi.es/like#", shortForm="like:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://plugin.org.uk/swh-plugins/", shortForm="swh:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://topbraid.org/sparqlmotionlib#", shortForm="sml:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2005/01/wai-rdf/GUIRoleTaxonomy#", shortForm="wairole:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.rdfabout.com/rdf/schema/vote/", shortForm="vote:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/biol/ns#", shortForm="biol:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/chord/", shortForm="co:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologies.ezweb.morfeo-project.org/eztag/ns#", shortForm="eztag:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://topbraid.org/sparqlmotion#", shortForm="sm:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/lx#", shortForm="lx:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/psychometric-profile/", shortForm="psych:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/riro/gpt#", shortForm="gpt:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.rkbexplorer.com/ontologies/resist#", shortForm="resist:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://spinrdf.org/sp#", shortForm="sp:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2005/07/aaa#", shortForm="states:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2008/turtle#", shortForm="ttl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.rkbexplorer.com/ontologies/acm#", shortForm="acm:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://telegraphis.net/ontology/geography/geography#", shortForm="geographis:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2008/05/skos-xl#", shortForm="skosxl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#", shortForm="nmo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/frbr/extended#", shortForm="frbre:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2003/01/geo/wgs84_pos#", shortForm="wgspos:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologi.es/colour/vocab#", shortForm="cv:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://spinrdf.org/spl#", shortForm="spl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2004/06/rei#", shortForm="rei:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2002/01/p3prdfv1#", shortForm="p3p:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://linkedevents.org/ontology/", shortForm="lode:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://schemas.talis.com/2005/service/schema#", shortForm="sv:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://inference-web.org/2.0/pml-relation.owl#", shortForm="pmlr:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.openrdf.org/config/sail/federation#", shortForm="fed:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/uri#", shortForm="uri:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologi.es/profiling#", shortForm="pr:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.openrdf.org/schema/sesame#", shortForm="sesame:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://data.linkedmdb.org/resource/movie/", shortForm="movie:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://eventography.org/sede/0.1/", shortForm="sede:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/net/provenance/ns#", shortForm="prv:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/net/vocab/2004/03/label#", shortForm="label:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://eulersharp.sourceforge.net/2003/03swap/log-rules#", shortForm="es:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.openrdf.org/rdf/2009/object#", shortForm="obj:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2004/02/image-regions#", shortForm="imreg:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://buzzword.org.uk/rdf/xen#", shortForm="xen:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://protege.stanford.edu/system#", shortForm="protege:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ontologies.ezweb.morfeo-project.org/ezcontext/ns#", shortForm="ezcontext:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/ns/auth/cert#", shortForm="cert:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.daml.org/2001/03/daml+oil#", shortForm="daml:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://musicontology.com/", shortForm="music:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/uwa/context/common.owl#", shortForm="common:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/commerce/product#", shortForm="product:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanticdesktop.org/ontologies/2007/03/22/nco#", shortForm="nco:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2005/Atom/", shortForm="atom:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2003/g/data-view#", shortForm="grddl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/puc#", shortForm="puc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/last-fm/", shortForm="lfm:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://demiblog.org/vocab/oauth#", shortForm="oauth:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/rss/1.0/modules/taxonomy/", shortForm="taxo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://buzzword.org.uk/rdf/personal-link-types#", shortForm="plink:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://dbpedia.org/class/yago/", shortForm="yago:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/symbolic-music/", shortForm="so:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://sw.cyc.com/CycAnnotations_v1#", shortForm="cycann:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/scovo#", shortForm="scv:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www4.wiwiss.fu-berlin.de/drugbank/resource/drugbank/", shortForm="drugbank:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/c4dm/timeline.owl#", shortForm="timeline:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/vocab/riro/ddl#", shortForm="ddl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://models.okkam.org/ENS-core-vocabulary#", shortForm="okkam:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.ontologydesignpatterns.org/ont/web/irw.owl#", shortForm="irw:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://climb.dataincubator.org/vocabs/climb/", shortForm="climb:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/media/audio#", shortForm="audio:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://hello.com/", shortForm="dummy:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/uwa/context/push.owl#", shortForm="push:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://a9.com/-/spec/opensearch/1.1/", shortForm="opensearch:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/acc#", shortForm="acc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://dbpedia.org/property/", shortForm="dbpp:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://scot-project.org/scot/ns#", shortForm="scot:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.holygoat.co.uk/owl/redwood/0.1/tags/", shortForm="tags:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontomedia/ext/common/profession#", shortForm="omp:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.openrdf.org/config/repository/sparql#", shortForm="sparql:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontology/last-fm/", shortForm="gob:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ontomedia/core/media#", shortForm="omm:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://web-semantics.org/ns/mysql/", shortForm="mysql:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/uwa/context/network.owl#", shortForm="net:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://ns.ontowiki.net/SysOnt/", shortForm="sysont:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanticdesktop.org/ontologies/2007/05/10/nexif#", shortForm="nexif:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/court/def/2009/coin#", shortForm="coin:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/net/ldap/", shortForm="ldap:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2006/03/wn/wn20/schema/", shortForm="wn20schema:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/uwa/context/software.owl#", shortForm="soft:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www4.wiwiss.fu-berlin.de/bizer/bsbm/v01/vocabulary/", shortForm="bsbm:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://moat-project.org/ns#", shortForm="moat:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://sw.opencyc.org/concept/", shortForm="cyc:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/linguistics/gold/", shortForm="gold:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/NET/dady#", shortForm="dady:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://inference-web.org/2.0/pml-justification.owl#", shortForm="pmlj:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://diplomski.nelakolundzija.org/LTontology.rdf#", shortForm="lt:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://webns.net/mvcb/", shortForm="admin:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://vocab.deri.ie/dcat#", shortForm="dcat:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.smileyontology.com/ns#", shortForm="smiley:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/ns/rdfa#", shortForm="rdfa:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.semanticdesktop.org/ontologies/2007/05/10/nid3#", shortForm="nid3:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://opengraphprotocol.org/schema/", shortForm="og:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://rdfs.org/sioc/actions#", shortForm="sioca:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://freedesktop.org/standards/xesam/1.0/core#", shortForm="xesam:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2003/01/geo/wgs84_pos#", shortForm="wgs:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://openprovenance.org/ontology#", shortForm="opm:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://vocab.deri.ie/rooms#", shortForm="rooms:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/2007/rif#", shortForm="rif:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://uriplay.org/spec/ontology/#", shortForm="play:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/ns/formats/", shortForm="formats:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://inference-web.org/2.0/pml-provenance.owl#", shortForm="pmlp:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/net/pingback/", shortForm="ping:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://openlinksw.com/schemas/oat/", shortForm="oat:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://dsnotify.org/vocab/eventset/0.1/", shortForm="evset:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://zeitkunst.org/bibtex/0.1/bibtex.owl#", shortForm="bib:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.lotico.com/meetup/", shortForm="meetup:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://inference-web.org/2.0/pml-trust.owl#", shortForm="pmlt:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://online-presence.net/opo/ns#", shortForm="opo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://rhizomik.net/ontologies/2008/05/copyrightonto.owl#", shortForm="copyright:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.w3.org/ns/sawsdl#", shortForm="sawsdl:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/ns/meteo#", shortForm="meteo:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://bblfish.net/work/atom-owl/2006-06-06/#", shortForm="awol:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://lod.taxonconcept.org/ontology/txn.owl#", shortForm="txn:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://purl.org/microformat/hmedia/", shortForm="ufmedia:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://www.kanzaki.com/ns/music#", shortForm="m:"})
lQuery.create("Onto#KnownPrefix", {fullForm="http://data.ordnancesurvey.co.uk/ontology/spatialrelations/", shortForm="spatialrelations:"})

end

--create the basic form to load ontology
function form()
	formAttributes =
		{caption = formCaption,
		id = formID,
		--will call event Close when X clicked at the top of the form
		buttonClickOnClose = false,
		--add that elements will be righ aligned
		--horizontalAlignment = 1,
		minimumWidth = 300,
		minimumHeight = 200
		}

	--Use utilities library to add and display form also auto delete form at end
	form = dialog.add_form (formAttributes)
		--add event handler that will close form when X clicked at the form top
		dialog.add_event_handlers(form, {Close = "lua.openProject.close"})
	--add buttons for ontology from file or ontology from endpoint
	local fileButton = d.add_component("D#Button", 	{caption = "Load from file", minimumWidth = 200, minimumHeight = 75} , form)
	dialog.add_event_handlers(fileButton, {Click = "lua.loadOntology.select_and_load_ontology"})
	local endpointButton = d.add_component("D#Button", 	{caption = "Load from SPARQL endpoint", minimumWidth = 200, minimumHeight = 75} , form)
	dialog.add_event_handlers(endpointButton, {Click = "lua.openProject.enterEndpoint"})
	print (formID)
	--show the form
	dialog.show_form(form)
end

--form to input SPARQL endpoint
function endpointForm()
	print ("clear")
	--if it is change button then we need to clear the form
	clearForm()
	--add all new elements to form
	local form = lQuery("D#Form[id='".. formID .. "']")
	local vBox = d.add_component("D#VerticalBox", 	{horizontalAlignment = -1, verticalAlignment = 0} , form)
	local label = d.add_component("D#Label", 	{caption = "Input SPARQL endpoint adress:"} , vBox)
	-- http://data.semanticweb.org/sparql
	--local input = d.add_component("D#InputField", 	{id = "EndpointInput", text = "http://194.8.1.251:8890/sparql"} , vBox)
	local input = d.add_component("D#InputField", 	{id = "EndpointInput", text = "http://127.0.0.1:8890/sparql"} , vBox)
	local vboxGraph = d.add_component("D#VerticalBox", 	{horizontalAlignment = -1, verticalAlignment = -1} , vBox)
	--pievienojam labeli, kur aicina ievadit grafu
	d.add_component("D#Label", 	{caption = "Input ontology named graph"} , vboxGraph)
	local inputGraph = d.add_component("D#InputField", 	{id = "namedGraphInput", text = ""} , vboxGraph)
	
	local hBox = d.add_component("D#HorizontalBox", 	{} , vBox)
	local hBox1 = d.add_component("D#HorizontalBox", 	{horizontalAlignment = -1} , hBox)
	local hBox2 = d.add_component("D#HorizontalBox", 	{horizontalAlignment = 1} , hBox)
	local okButton = d.add_component("D#Button", 	{caption = "OK"} , hBox2)
		dialog.add_event_handlers(okButton, {Click = "lua.openProject.spyEndpoint"})
	local listEndpoints = d.add_component("D#Button", 	{caption = "List known endpoints"} , hBox1)
	dialog.add_event_handlers(listEndpoints, {Click = "lua.openProject.endpointList"})

end

function spyEndpoint()
	print ("spy")
	local endpoint
	if lQuery("D#InputField[id = 'EndpointInput']"):is_not_empty() then
		endpoint = lQuery("D#InputField[id = 'EndpointInput']"):attr("text")
		namedGraphName = lQuery("D#InputField[id = 'namedGraphInput']"):attr("text")
	else
		endpoint =  lQuery("D#ListBox[id = 'EndpointList']"):find("/selected"):attr("value")
	end
	lQuery("Onto#Endpoint"):delete()
	local ontoEndpoint = lQuery.create("Onto#Endpoint")
	ontoEndpoint:attr("url", endpoint)
	--lQuery.model.add_property("Onto#Endpoint", "namedGraph")
	ontoEndpoint:attr("namedGraph", namedGraphName)
	onto.onto()
	closeForm()

end

function defaultEndpointForm ()
	--if it is change button then we need to clear the form
	clearForm()

	--add all new elements to form
	local form = lQuery("D#Form[id='".. formID .. "']")

	local vBox = d.add_component("D#VerticalBox", 	{horizontalAlignment = -1} , form)
	local label = d.add_component("D#Label", 	{caption = "Choose from list:"} , vBox)
	local input = d.add_component("D#ListBox", 	{id = "EndpointList"} , vBox)
	local hBox = d.add_component("D#HorizontalBox", 	{} , vBox)
	local hBox1 = d.add_component("D#HorizontalBox", 	{horizontalAlignment = -1} , hBox)
	local hBox2 = d.add_component("D#HorizontalBox", 	{horizontalAlignment = 1} , hBox)
	local okButton = d.add_component("D#Button", 	{caption = "OK"} , hBox2)
	dialog.add_event_handlers(okButton, {Click = "lua.openProject.spyEndpoint"})
	local listEndpoints = d.add_component("D#Button", 	{caption = "Enter endpoint adress"} , hBox1)
	dialog.add_event_handlers(listEndpoints, {Click = "lua.openProject.enterEndpoint"})

	--add enpoint list
	addEndpoints(input)
end

function addEndpoints (listBox)
	local t1 = lQuery.create("D#Item", {value = "http://data.semanticweb.org/sparql"}):link("listBox", listBox)
	t1:link ("parentListBox", listBox)
	lQuery.create("D#Item", {value = "http://data.linkedmdb.org/sparql"}):link("listBox", listBox)
	lQuery.create("D#Item", {value = "http://semantic.eea.europa.eu/sparql"}):link("listBox", listBox)
	lQuery.create("D#Item", {value = "http://education.data.gov.uk/sparql/education/query"}):link("listBox", listBox)
	lQuery.create("D#Item", {value = "http://transport.data.gov.uk/sparql/transport/query"}):link("listBox", listBox)
	lQuery.create("D#Item", {value = "http://reference.data.gov.uk/sparql/reference/query"}):link("listBox", listBox)
	--lQuery.create("D#Item", {value = "http://api.talis.com/stores/ordnance-survey/services/sparql"}):link("listBox", listBox)
	--lQuery.create("D#Item", {value = ""}):link("listBox", listBox)
end

--creates a form where is it possible to enter an endpoint
function enterEndpoint ()
	endpointForm()
	dialog.refresh_form_component(lQuery("D#Form[id='".. formID .. "']"))

end

--form that contains default endpoint list to where one can connect
function endpointList ()
	defaultEndpointForm()
	dialog.refresh_form_component(lQuery("D#Form[id='".. formID .. "']"))

end

--clear the form from all the elements
function clearForm()
	local form = lQuery("D#Form[id='".. formID .. "']")
	local components = form:transitive_closure("/component"):remove(form)
	components:delete()
end


function closeForm ()
	--form = lQuery("D#Form[id='ConnectEndpoint']"):link("command", function() return utilities.execute_cmd("D#Command", {info = "Close"}) end)
--	local endpoint
--	if lQuery("D#InputField[id = 'EndpointInput']"):is_not_empty() then
--		endpoint = lQuery("D#InputField[id = 'EndpointInput']"):attr("text")
--	else
--		endpoint =  lQuery("D#ListBox[id = 'EndpointList']"):find("/selected"):attr("value")
--	end
--	lQuery("Onto#Endpoint"):delete()
--	local ontoEndpoint = lQuery.create("Onto#Endpoint")
--	ontoEndpoint:attr("url", endpoint)
--	onto.onto()
	dialog.close_form(formID)
	--
end

function close()
	dialog.close_form(formID)
end

--[[
function spyEndpoint()
	spy.delete_onto()
	input = lQuery("D#Component[id = 'EndpointInput']")
	local endpoint = input:attr("text")
	spy.spy_endpoint("http://194.8.1.251:8890/sparql")
	recalc.associations()
end
--]]
