module(..., package.seeall)

--local lumiiRep = "lua_mii_rep"
--local lQuery = require "lQuery"
--local io = require("socket.url")

function export()
	--io.open(ontology.ttl, w+)
	local file = assert(io.open("ontology.ttl", "w+"))
	--file:write("Hello world")

	text = [[
	@prefix xsd: <http://www.w3.org/2001/XMLSchema#> .
	@prefix owl: <http://www.w3.org/2002/07/owl#> .
	@prefix rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> .
	@prefix rdfs: <http://www.w3.org/2000/01/rdf-schema#> .
	]]
	file:write(text)

	--izdrukajam klases
	lQuery("Onto#Class"):each(
	function (klase)
		text = "<" .. klase:attr("URI") .. "> rdf:type owl:Class; \n"
		file:write(text)
		text = "\t rdfs:label \"" ..klase:attr("name").."\".\n"
		file:write(text)
	end
	)

	--pievienojam apaksklases relacijas
	lQuery("Onto#Class"):each(
	function (klase)
		klase:find("/superClass"):each(
			function (superklase)
				text = "<"..klase:attr("URI") .. "> rdfs:subClassOf <" ..superklase:attr("URI")..">.\n"
				file:write(text)
			end
		)
	end
	)

	lQuery("Onto#Attribute"):each(
	function (attribute)
		text = "<" .. attribute:attr("URI") .. "> rdf:type owl:DatatypeProperty; \n"
		file:write(text)
			attribute:find("/class"):each(
				function (klase)
					text = "\t rdfs:domain <" ..klase:attr("URI")..">;\n"
					file:write(text)
				end
			)
		--Formali vajag rupigaku datu tipu parlasi, jo protege, nav tikai XML schemas datu tipi
		--print (attribute:attr("type"))
		--print ("test attr")
		if attribute:attr("type") ~= "NA" and attribute:attr("type") ~= "" and attribute:attr("type") ~= nil then
			text = "\t rdfs:range xsd:" ..attribute:attr("type")..";\n"
			file:write(text)
		else
			text = "\t rdfs:range xsd:string;\n"
			file:write(text)
		end
		text = "\t rdfs:label \"" ..attribute:attr("name").."\".\n"
		file:write(text)
	end
	)

	lQuery("Onto#Association"):each(
	function (association)
		text = "<" .. association:attr("URI") .. "> rdf:type owl:ObjectProperty; \n"
		file:write(text)
			association:find("/domain"):each(
				function (klase)
					text = "\t rdfs:domain <" ..klase:attr("URI")..">;\n"
					file:write(text)
				end
			)
			association:find("/range"):each(
				function (klase)
					text = "\t rdfs:range <" ..klase:attr("URI")..">;\n"
					file:write(text)
				end
			)
		text = "\t rdfs:label \"" ..association:attr("name").."\".\n"
		file:write(text)
	end
	)

end
