--require "../lua_mii_rep"
--lQuery = require "lQuery"
module(..., package.seeall)

--require "lua_mii_rep"
--local lQuery = require "lQuery"

function create_model()
	lQuery.model.add_class("Onto#Element")
		--lQuery.model.add_property("Onto#Element", "name") --onto elementa vards, ko paradit
		lQuery.model.add_property("Onto#Element", "URI") --elementa URI
		lQuery.model.add_property("Onto#Element", "namespace") -- elementa Namespace
		lQuery.model.add_property("Onto#Element", "localName") --ja ar label nav uzdots vards, ko radit, tad nem localName
		lQuery.model.add_property("Onto#Element", "name")
	lQuery.model.add_class("Onto#Class")
		lQuery.model.add_property("Onto#Class", "type") --we define three possible class types - typed, that means objects has rdf:type association, user, that means that user defined attributes that defines class, automatic, that means that possible attributes was defined by extraction algorithm.
		lQuery.model.add_property("Onto#Class", "instanceCount")
		lQuery.model.add_property("Onto#Class", "traversed")
		lQuery.model.set_super_class("Onto#Class", "Onto#Element")
	lQuery.model.add_class("Onto#Association")
		lQuery.model.add_property("Onto#Association", "type") --define possible types for association - typed, deducted
		lQuery.model.add_property("Onto#Association", "instanceCount")
		lQuery.model.set_super_class("Onto#Association", "Onto#Element")
	lQuery.model.add_class("Onto#Attribute")
		lQuery.model.set_super_class("Onto#Attribute", "Onto#Element")
	lQuery.model.add_class("Onto#Primitive") --Primitivie atributi, kam ir vienkarsais datu tips
		lQuery.model.add_property("Onto#Primitive", "type")
		lQuery.model.add_property("Onto#Primitive", "isEnum")
		lQuery.model.add_property("Onto#Primitive", "differentValues")
		lQuery.model.set_super_class("Onto#Primitive", "Onto#Attribute")
	lQuery.model.add_class("Onto#Enumeration") --Parskaitamie datu tipi
		lQuery.model.set_super_class("Onto#Enumeration", "Onto#Attribute")
	lQuery.model.add_class("Onto#ComplexAttribute") --attributi, kas sastav no vairakam vertibam
		lQuery.model.set_super_class("Onto#ComplexAttribute", "Onto#Attribute")
	--pievienojam klasi, kas lauj visiem elementiem pievienot anotacijas, ko velak var apstradat dazados veidos
	lQuery.model.add_class("Onto#Anotation")
		lQuery.model.add_property("Onto#Anotation", "type")
		lQuery.model.add_property("Onto#Anotation", "value")
		lQuery.model.add_property("Onto#Anotation", "language")
	--Class associations
	lQuery.model.add_link("Onto#Class","class","attribute","Onto#Attribute")
	lQuery.model.add_link("Onto#Class","optionalClass","optionalAttr","Onto#Attribute")
--	lQuery.model.add_link("Onto#Class","domain","domainAssoc","Onto#Association")
--	lQuery.model.add_link("Onto#Class","range","rangeAssoc","Onto#Association")
	lQuery.model.add_link("Onto#Class","superClass","subClass","Onto#Class")

	--Attribute associations
	lQuery.model.add_link("Onto#Attribute","constructAttr","complexAttr","Onto#Attribute")
	lQuery.model.add_link("Onto#Attribute","superAttr","subAttr","Onto#Attribute")

	--Association
	lQuery.model.add_link("Onto#Association","superAssoc","subAssoc","Onto#Association")
	lQuery.model.add_link("Onto#Association","inverseOf","inverse","Onto#Association")

	--Annotation
	lQuery.model.add_link("Onto#Anotation","anotation","element","Onto#Element")
	lQuery.model.add_link("Onto#Anotation","subAnotation","superAnotation","Onto#Anotation")

	lQuery.model.add_class("Onto#Endpoint")
		lQuery.model.add_property("Onto#Endpoint", "url") --endpointa adrese
		lQuery.model.add_property("Onto#Endpoint", "namedGraph") --endpointa grafs, no kura vaica
		
		
	lQuery.model.delete_link ("Onto#Association", "range")
	lQuery.model.delete_link ("Onto#Association", "domain")

	lQuery.model.add_class("Onto#AllAssociation")
	lQuery.model.add_class("Onto#SubAssociation")
	lQuery.model.add_class("Onto#SuperSubAssociation")
	lQuery.model.add_class("Onto#SuperAssociation")

	lQuery.model.add_link("Onto#Class","domain","domainAssoc","Onto#AllAssociation")
	lQuery.model.add_link("Onto#Class","range","rangeAssoc","Onto#AllAssociation")
	lQuery.model.add_link("Onto#AllAssociation","derived","from","Onto#Association")

	lQuery.model.add_link("Onto#Class","subClass","subAssociation","Onto#SubAssociation")

	lQuery.model.add_link("Onto#Class","subClass","subSuperAssociationAsSub","Onto#SuperSubAssociation")
	lQuery.model.add_link("Onto#Class","superClass","subSuperAssociationAsSup","Onto#SuperSubAssociation")

	lQuery.model.set_super_class("Onto#AllAssociation", "Onto#Element")

	lQuery.model.set_super_class("Onto#Association", "Onto#AllAssociation")
	lQuery.model.set_super_class("Onto#SubAssociation", "Onto#AllAssociation")
	lQuery.model.set_super_class("Onto#SuperSubAssociation", "Onto#AllAssociation")
	lQuery.model.set_super_class("Onto#SuperAssociation", "Onto#AllAssociation")

	lQuery.model.add_class("Onto#Parameter")
		lQuery.model.add_property("Onto#Parameter", "name")
		lQuery.model.add_property("Onto#Parameter", "value")
  --return
end
